package apap.tutorial.belajarbelajar.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import apap.tutorial.belajarbelajar.model.CourseModel;
import apap.tutorial.belajarbelajar.service.CourseService;

import java.util.List;

@Controller
public class CourseController {
    @Autowired
    private CourseService courseService;

    @RequestMapping("course/add")
    public String addCourse(
            @RequestParam(value = "code", required = true) String code,
            @RequestParam(value = "nameCourse", required = true) String nameCourse,
            @RequestParam(value = "description", required = true) String description,
            @RequestParam(value = "jumlahSks", required = true) String jumlahSks,
            Model model) {
        for (CourseModel object : courseService.getListCourse()){
            if (code.equalsIgnoreCase(object.getCode())){
                return "notifikasi-gagal-add";
            }
        }
        CourseModel course = new CourseModel(code, nameCourse, description, Integer.parseInt(jumlahSks));

        courseService.addCourse(course);
        model.addAttribute("code", code);
        model.addAttribute("nameCourse", nameCourse);

        return "add-course";
    }
    @RequestMapping("course/viewAll")
    public String listCourse(Model model) {
        List<CourseModel> listCourse = courseService.getListCourse();
        model.addAttribute("listCourse", listCourse);
        return "viewall-course";
    }

    @RequestMapping("course/view")
    public String detailCourse(@RequestParam(value = "code") String code, Model model) {
        // Mendapatkan CourseModel sesuai dengan code
        CourseModel course = courseService.getCourseByCodeCourse(code);
        // Add variabel semua courseModel ke "course" untuk dirender pada thymeleaf
        model.addAttribute("course", course);
        return "view-course";
    }

    @GetMapping("course/view/code-course/{code}")
    public String detailCoursePathVariable(@PathVariable(value = "code") String code, Model model) {
        // Mendapatkan CourseModel sesuai dengan code
        CourseModel course = courseService.getCourseByCodeCourse(code);
        // Add variabel semua courseModel ke "course" untuk dirender pada thymeleaf
        model.addAttribute("course", course);
        return "view-course";
    }

    @GetMapping("course/update/code-course/{code}/jumlah-sks/{sks}")
    public String updateBanyakSks( @PathVariable(value = "code") String code, @PathVariable(value = "sks") int sks, Model model) {
        // Mendapatkan CourseModel sesuai dengan code
        CourseModel course = courseService.getCourseByCodeCourse(code);
        // Update variabel jumlahSks
        course.setJumlahSks(sks);
        model.addAttribute("course", course);
        return "berhasil-ditambahkan";
    }


//    }
@GetMapping("course/delete/code-course/{code}")
public String deleteCourse(@PathVariable(value = "code") String code, Model model) {
    CourseModel course = courseService.getCourseByCodeCourse(code);
    List<CourseModel> listCourse = courseService.getListCourse();
//    listCourse.remove(course);
    model.addAttribute("course", course);
    if (courseService.getListCourse().contains(code) == false) {
        return "notifikasi-delete";
    }
    else {
        listCourse.remove(course);
        model.addAttribute("course", course);
        return "delete-course";
    }
}



}